#!/usr/bin/env python3
# split.py

"""Split STM8S IntelHex output"""

import re
import intelhex

################################################################################
# Intelhex image
img = None

################################################################################
# Main program
def main(argv):
    """
    Split hex file apart
    """
    # Get filename
    if 1 < len(argv):
        filename = argv[1]
    # Read file
    global img
    img = intelhex.IntelHex(filename)
    # Get base name
    basename = re.sub(r"_all\.hex$", "", filename, 1)
    # hex outputs normal
    print("Writing hex files program/data/options")
    img[0x008000:0x010000].tofile(basename + "_program.hex", "hex")
    img[0x004000:0x004400].tofile(basename + "_data.hex", "hex")
    img[0x004800:0x004900].tofile(basename + "_option.hex", "hex")

################################################################################
# Execute
if __name__ == "__main__":
    import sys
    sys.exit(main(sys.argv))
